#include <string>
#include <iostream>
#include "ipaddress.h" 
#include <string.h>
#include <iomanip.h>
#include <iomanip>
#include <stdio.h>




IPAddress::IPAddress(unsigned int address, unsigned int maskLength)
{
	address_ = address;
	maskLength_ = maskLength;
}


IPAddress::IPAddress(string address)
{
  
  unsigned int a1, a2, a3, a4;
  /* Match first octet */
  char octet[4];
  unsigned int pos;
  octet[0] = address[0];
  for(pos = 1; (pos < 5) && (address[pos] != '.'); pos++)
    octet[pos] = address[pos];
  pos++;  /* Go past the . */
  octet[pos] = '\0';
  a1 = (unsigned int) atoi(octet) << 24;
  
  int octPos;
  for(octPos = 0; address[pos] != '.'; pos++)
    {
      octet[octPos] = address[pos];
      octPos++;
    }
  octet[octPos] = '\0';
  
  a2 = (unsigned int) atoi(octet) << 16;
  
  pos++;
  
  for(octPos = 0; address[pos] != '.'; pos++)
    {
      octet[octPos] = address[pos];
      octPos++;
    }
  
  octet[octPos] = '\0';
  a3 = (unsigned int) atoi(octet) << 8;
  pos++;
  
  
  for(octPos = 0; address[pos] != '/'; pos++)
    {
      octet[octPos] = address[pos];
      octPos++;
    }
  
  octet[octPos] = '\0';
  a4 = (unsigned int) atoi(octet);
  address_ = a1 + a2 + a3 + a4;
  
  pos++;
  octPos=0;
  while(pos < address.size())
    {
      octet[octPos] = address[pos];
      octPos++; pos++;
    }
  octet[octPos] = '\0';
  maskLength_ = (unsigned int) atoi(octet);
  
}


IPAddress::~IPAddress()
{
  ;
}

unsigned int IPAddress::getMaskLength()
{
	return maskLength_;
}

IPAddress IPAddress::net()
{

  unsigned int netmask=0xFFFFFFFF;
  netmask = netmask >> maskLength_;
  
  netmask = ~netmask;
  return IPAddress(netmask&address_, maskLength_);
}


IPAddress IPAddress::host()
{
 
  unsigned int netmask=0xFFFFFFFF;
  netmask = netmask >> maskLength_;

  return IPAddress(netmask&address_, maskLength_);
}

bool IPAddress::isBroadcast()
{
  unsigned int hostmask=0xFFFFFFFF;
  hostmask = hostmask >> maskLength_;
  unsigned int host = address_ & hostmask;
  if (hostmask == host)
    return true;
  else 
    return false;

}
string IPAddress::toString()
{
  char *s = new char[20];

  unsigned int mask = 0xFF000000;

  unsigned int octet1,octet2,octet3,octet4;
  octet1 = address_ & mask;
  octet1 = octet1 >> 24;

  mask = 0x00FF0000;
  octet2 = address_ & mask;
  octet2 = octet2 >> 16;
  
  mask = 0x0000FF00;
  octet3 = address_ & mask;
  octet3 = octet3 >> 8;
  
  mask = 0x000000FF;
  octet4 = address_ & mask;
  

  sprintf(s, "%d.%d.%d.%d", octet1,octet2,octet3,octet4);
  return string(s);
}
string IPAddress::toStringPrefix()
{

  string addy = toString();
  char *s = new char[addy.size()+4];
  strcpy(s, addy.c_str());
  s[addy.size()] = '/';
  sprintf(s+addy.size()+1, "%d", maskLength_);
  s[addy.size()+3] = '\0';
  return string(s);
}

  
  
const bool IPAddress::operator== (const IPAddress &IP)
{
  if( (address_ != IP.address_) || (maskLength_ != IP.maskLength_) )
    return false;
  return true;
}

 bool IPAddress::match(IPAddress a)
{
  if(a.maskLength_ == 0 || maskLength_ == 0)
    return true;

  return (a.net() == net());
}











