/* vRouter: network.h
 *
 *  Purpose: Encapsulate network and datalink objects that
 *           constitute a network
 *
 *  Changes:
 *  
 *   0.02 - Intial Release
 */
#ifndef NETWORK_H
#define NETWORK_H


/* Declare this first so we don't have problems later on */
class Network;

#include "router.h"

#include <vector>
#include <string>



class Network
{
  
 public:
  Network();
  ~Network();

  void addRouter(Router *);
  void addDataLink(DataLink *);
  void clear();

  Router * getRouterByName(string);
  DataLink * getDataLinkByAddress(IPAddress);

  
  /* these must be accessable by the Simulator */
  vector<DataLink *> dataLinks;
  vector<Router *> routers;

};

#endif // #ifndef NETWORK_H
